Mario.Input = function(game){
    this.game = game;
    var wrapper = document.getElementById('mario');
    wrapper.focus();
	wrapper.onkeydown = this.keydown.bind(this);
	wrapper.onkeyup = this.keyup.bind(this);
	wrapper.onkeypress = function(e){
	    switch (e.keyCode) {
			case Mario.Enum.KEY_LEFT:
			case Mario.Enum.KEY_UP:
			case Mario.Enum.KEY_RIGHT:
			case Mario.Enum.KEY_DOWN:
			case Mario.Enum.KEY_1:
			case Mario.Enum.KEY_2:
			case Mario.Enum.KEY_3:
			    return false;
		}
	};
};

Mario.Input.prototype = {
	held: {},
	pressed: {},
	keydown: function(e){
		switch (e.keyCode) {
			default:
				relog("key code: "+e.keyCode);
				return; // dont cancel event
			case Mario.Enum.KEY_LEFT:
				this.pressed.left = true;
				this.pressed.right = false;
				this.held.left = true;
				this.held.right = false;
				break;
			case Mario.Enum.KEY_UP:
				this.pressed.up = true;
				this.pressed.down = false;
				this.held.up = true;
				this.held.down = false;
				break;
			case Mario.Enum.KEY_RIGHT:
				this.pressed.right = true;
				this.pressed.left = false;
				this.held.right = true;
				this.held.left = false;
				break;
			case Mario.Enum.KEY_DOWN:
				this.pressed.down = true;
				this.pressed.up = false;
				this.held.down = true;
				this.held.up = false;
				break;
			case Mario.Enum.KEY_1:
				this.pressed.one = true;
				break;
			case Mario.Enum.KEY_2:
				this.pressed.two = true;
				break;
			case Mario.Enum.KEY_3:
				this.pressed.three = true;
				break;
		}
		return false; // cancel event
	},
	keyup: function(e){
		switch (e.keyCode) {
			default:
				return; // dont cancel event
			case Mario.Enum.KEY_LEFT:
				this.held.left = false;
				break;
			case Mario.Enum.KEY_UP:
				this.held.up = false;
				break;
			case Mario.Enum.KEY_RIGHT:
				this.held.right = false;
				break;
			case Mario.Enum.KEY_DOWN:
				this.held.down = false;
				this.game.setActorIdle();
				break;
		}
		return false; // cancel event
	},
	
	frame: function(){
		if (this.pressed.down && this.held.down) {
			// duck, only if key not already released
			this.game.duck();
		} else if (!this.held.down) {
			if (this.pressed.left || this.held.left) {
			    this.game.runLeft();
			} else if (this.pressed.right || this.held.right) {
			    this.game.runRight();
			}
			if (this.pressed.up || this.held.up) {
			    this.game.jump();
			}
		} 
		
		if (this.pressed.one) this.game.makeSmall();
		if (this.pressed.two) this.game.makeBig();
		if (this.pressed.three) this.game.fire();

		this.pressed = {};
	}
};